# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class SearchOrdersFulfillmentFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, fulfillment_types=None, fulfillment_states=None):
        """
        SearchOrdersFulfillmentFilter - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'fulfillment_types': 'list[str]',
            'fulfillment_states': 'list[str]'
        }

        self.attribute_map = {
            'fulfillment_types': 'fulfillment_types',
            'fulfillment_states': 'fulfillment_states'
        }

        self._fulfillment_types = fulfillment_types
        self._fulfillment_states = fulfillment_states

    @property
    def fulfillment_types(self):
        """
        Gets the fulfillment_types of this SearchOrdersFulfillmentFilter.
        List of [fulfillment types](#type-orderfulfillmenttype) to filter for. Will return orders if any of its fulfillments match any of the fulfillment types listed in this field. See [OrderFulfillmentType](#type-orderfulfillmenttype) for possible values

        :return: The fulfillment_types of this SearchOrdersFulfillmentFilter.
        :rtype: list[str]
        """
        return self._fulfillment_types

    @fulfillment_types.setter
    def fulfillment_types(self, fulfillment_types):
        """
        Sets the fulfillment_types of this SearchOrdersFulfillmentFilter.
        List of [fulfillment types](#type-orderfulfillmenttype) to filter for. Will return orders if any of its fulfillments match any of the fulfillment types listed in this field. See [OrderFulfillmentType](#type-orderfulfillmenttype) for possible values

        :param fulfillment_types: The fulfillment_types of this SearchOrdersFulfillmentFilter.
        :type: list[str]
        """

        self._fulfillment_types = fulfillment_types

    @property
    def fulfillment_states(self):
        """
        Gets the fulfillment_states of this SearchOrdersFulfillmentFilter.
        List of [fulfillment states](#type-orderfulfillmentstate) to filter for. Will return orders if any of its fulfillments match any of the fulfillment states listed in this field. See [OrderFulfillmentState](#type-orderfulfillmentstate) for possible values

        :return: The fulfillment_states of this SearchOrdersFulfillmentFilter.
        :rtype: list[str]
        """
        return self._fulfillment_states

    @fulfillment_states.setter
    def fulfillment_states(self, fulfillment_states):
        """
        Sets the fulfillment_states of this SearchOrdersFulfillmentFilter.
        List of [fulfillment states](#type-orderfulfillmentstate) to filter for. Will return orders if any of its fulfillments match any of the fulfillment states listed in this field. See [OrderFulfillmentState](#type-orderfulfillmentstate) for possible values

        :param fulfillment_states: The fulfillment_states of this SearchOrdersFulfillmentFilter.
        :type: list[str]
        """

        self._fulfillment_states = fulfillment_states

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
